import es, playerlib, services, os, path, langlib, cfglib, gamethread

info = es.AddonInfo()
info.name = "LooneyChat"
info.version = "1.2"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=26133"
info.author = "Satoon101"
es.ServerVar("looneychat_version",info.version,"looneychat_version").makepublic()

config = cfglib.AddonCFG(es.getAddonPath('looneychat') + '/lc_config.cfg')
config.text("***************************\n// ** AUTH_Provider Options **\n// ***************************")
looney_admins = config.cvar('looney_admins', '', "There are 3 ways to add Admins, 1st is to use an Auth_Provider in Eventscripts\n// 2nd is to use your Mani_Admin_Plugin clients.txt file\n// and third is to add SteamID's below in format:\n// looney_admins \"'STEAM_0:1:1234567','STEAM_0:1:7654321','etc...'\"")
config.text('\n')
config.text("****************************\n// ** ADMIN TO ADMIN Options **\n// ****************************")
lc_admin_admin = config.cvar('lc_admin_admin', 1, 'Set to Enable/Disable Admin to Admin Speech')
looney_admin_admin = config.cvar('looney_admin_admin', '@others', 'Set to text for Admin to Admin Speech (change only text inside "")')
config.text('\n')
config.text("*****************************\n// ** ADMIN TO PLAYER Options **\n// *****************************")
lc_admin_player = config.cvar('lc_admin_player', 1, 'Set to Enable/Disable Admin to Player Speech')
looney_admin_player = config.cvar('looney_admin_player', '@player', 'Set to text for Admin to Player Speech (change only text inside "")')
config.text('\n')
config.text("*****************************\n// ** PLAYER TO ADMIN Options **\n// *****************************")
lc_player_admin = config.cvar('lc_player_admin', 1, 'Set to Enable/Disable Player to Admins Speech')
looney_player_admin = config.cvar('looney_player_admin', '@admin', 'Set to text for Player to Admins Speech (change only text inside "")')
config.text('\n')
config.text("*********************************\n// ** ADMINS SEE ALL TEXT Options **\n// *********************************")
lc_alltext = config.cvar('lc_alltext', 1, 'Set to Enable/Disable Admins See ALL Text')
config.text('\n')
config.text("*******************************\n// ** ANNOUNCE COMMANDS Options **\n// *******************************")
lc_announcements = config.cvar('lc_announcements', 1, '0 = No Announcements, 1 = Announce using Rounds, 2 = Announce using Time')
lc_admin_announce = config.cvar('lc_admin_announce', 3, 'Set to number of rounds/minutes between announce to Admins about Admin Commands (0 = No Announcement)')
lc_player_announce = config.cvar('lc_player_announce', 3, 'Set to number of rounds/minutes between announce to Players about Player Commands (0 = No Announcement)')
lc_announce_admins = config.cvar('lc_announce_admins', 1, 'Set to Enable/Disable announcement of Admins currently on server to non-Admins (only if lc_player_rounds > 0)')
config.write()
lc_gamedir = path.path(str(es.ServerVar('eventscripts_gamedir')))
lc_lang = langlib.Strings(es.getAddonPath('looneychat') + '/strings.ini')
lc_admin_round_count = 0
lc_player_round_count = 0
lc_online_admins = []
lc_non_admins = []
mani_admins = []

def load():
    config.execute()
    gamethread.delayed(0, settings)

def settings():
    if lc_admin_admin == 1:
        es.regsaycmd(looney_admin_admin, 'looneychat/admin_admin_talk', 'Send admin to admin text')
    if lc_admin_player == 1:
        es.regsaycmd(looney_admin_player, 'looneychat/admin_player_talk', 'Send admin to player text')
    if lc_player_admin == 1:
        es.regsaycmd(looney_player_admin, 'looneychat/player_admin_talk', 'Send player to admin text')
    if lc_announcements == 2:
        if lc_admin_announce > 0 and (lc_admin_player == 1 or lc_admin_admin == 1):
            gamethread.delayedname(lc_admin_announce * 60, 'lc_admin_delay', announce_admin)
        if lc_player_announce > 0 and lc_player_admin == 1:
            gamethread.delayedname(lc_player_announce * 60, 'lc_player_delay', announce_player)
    find_Admins()

def find_Admins():
    global mani_admins, isAdmin
    for x in mani_admins:
        mani_admins.remove(x)
    mani_file = lc_gamedir.joinpath('cfg/mani_admin_plugin/clients.txt')
    if os.path.isfile(mani_file):
        a = open(mani_file, 'r')
        b = a.readlines()
        a.close()
        for c in b:
            c = c.replace('\t','').replace(' ','').replace('\n','')
            if '"steam""STEAM_' in c:
                mani_admins.append(c.replace('"steam""', '').replace('"', ''))
    if services.isRegistered('auth'):
        auth = services.use('auth')
        auth.registerCapability('looneychat', auth.ADMIN)
        isAdmin = lambda x: auth.isUseridAuthorized(x, 'looneychat')
    else:
        isAdmin = lambda x: False

def is_Admin(userid):
    if isAdmin(userid) or (es.getplayersteamid(userid) in str(es.ServerVar('looney_admins')).replace("'",'').split(',')) or es.getplayersteamid(userid) in mani_admins:
        return True
    else:
        return False

def round_start(ev):
    if lc_announcements == 1:
        checkrounds()

def dod_round_start(ev):
    if lc_announcements == 1:
        checkrounds()

def teamplay_round_start(ev):
    if lc_announcements == 1:
        checkrounds()

def checkrounds():
    global lc_admin_round_count, lc_player_round_count
    if lc_admin_announce > 0 and (lc_admin_player == 1 or lc_admin_admin == 1):
        lc_admin_round_count += 1
        if lc_admin_round_count == lc_admin_announce:
            lc_admin_round_count = 0
            announce_admin()
    if lc_player_announce > 0 and lc_player_admin == 1:
        lc_player_round_count += 1
        if lc_player_round_count == lc_player_announce:
            lc_player_round_count = 0
            announce_player()

def announce_admin():
    if lc_announcements == 2:
        gamethread.delayedname(lc_admin_announce * 60, 'lc_admin_delay', announce_admin)
    for admins in playerlib.getPlayerList('#human'):
        admin = int(admins)
        if is_Admin(admin):
            lc_admin_lang = playerlib.getPlayer(admin).get('lang')
            if lc_admin_admin == 1:
                es.tell(admin, '#multi', lc_lang('Ad2Ad',{'command':looney_admin_admin},lc_admin_lang))
            if lc_admin_player == 1:
                es.tell(admin, '#multi', lc_lang('Ad2Pl',{'command':looney_admin_player},lc_admin_lang))

def announce_player():
    if lc_announcements == 2:
        gamethread.delayedname(lc_admin_announce * 60, 'lc_player_delay', announce_player)
    for x in lc_online_admins:
        lc_online_admins.remove(x)
    for x in lc_non_admins:
        lc_non_admins.remove(x)
    for non_admins in playerlib.getPlayerList('#human'):
        non_admin = int(non_admins)
        if not is_Admin(non_admin):
            es.tell(non_admin, '#multi', lc_lang('Pl2Ad',{'command':looney_player_admin},playerlib.getPlayer(non_admin).get('lang')))
            if lc_announce_admins == 1:
                lc_non_admins.append(non_admin)
        elif lc_announce_admins == 1:
            lc_online_admins.append(non_admin)
    if lc_announce_admins == 1:
        total_admins = 0
        for lc_non_admin in lc_non_admins:
            lc_non_admin_lang = playerlib.getPlayer(lc_non_admin).get('lang')
            text = lc_lang('Online Admins',lang=lc_non_admin_lang)
            for lc_online_admin in lc_online_admins:
                lc_admin_name = es.getplayername(lc_online_admin)
                if total_admins == 0:
                    text = '%s %s'%(text, lc_admin_name)
                    total_admins = 1
                else:
                    text = '%s#default,#lightgreen %s'%(text, lc_admin_name)
            if total_admins == 1:
                es.tell(lc_non_admin, '#multi', '%s'%text)
            else:
                es.tell(lc_non_admin, '#multi', lc_lang('No Admins',lang=lc_non_admin_lang))

def admin_admin_talk():
    userid = es.getcmduserid()
    lc_user_lang = playerlib.getPlayer(userid).get('lang')
    words = es.getargc()
    if is_Admin(userid):
        if words > 1:
            text = es.getargv(1)
            for word in range(2, words):
                next = es.getargv(word)
                text = '%s %s'%(text, next)
            for admins in playerlib.getPlayerList('#human'):
                admin = int(admins)
                if is_Admin(admin) and admin != userid:
                    es.tell(admin, '#multi', lc_lang('Admin to Admins',{'sender':es.getplayername(userid),'text':text},playerlib.getPlayer(admin).get('lang')))
        else:
            es.tell(userid, '#multi', lc_lang('Syntax1',{'command':looney_admin_admin},lc_user_lang))
    else:
        es.tell(userid, '#multi', lc_lang('AdminOnly',{'command':looney_admin_admin},lc_user_lang))

def admin_player_talk():
    userid = es.getcmduserid()
    lc_user_lang = playerlib.getPlayer(userid).get('lang')
    words = es.getargc()
    if is_Admin(userid):
        if words > 2:
            playername = es.getargv(1)
            player = es.getuserid(playername)
            if player != 0:
                if es.getplayersteamid(player) != 'BOT':
                    text = es.getargv(2)
                    for word in range(3, words):
                        next = es.getargv(word)
                        text = '%s %s'%(text, next)
                    es.tell(player, '#multi', lc_lang('Admin to Player',{'sender':es.getplayername(userid),'text':text},playerlib.getPlayer(player).get('lang')))
                else:
                    es.tell(userid, '#multi', lc_lang('BOT',{'playername':playername},lc_user_lang))
            else:
                es.tell(userid, '#multi', lc_lang('Invalid Player',{'playername':playername},lc_user_lang))
        else:
            es.tell(userid, '#multi', lc_lang('Syntax2',{'command':looney_admin_player},lc_user_lang))
    else:
        es.tell(userid, '#multi', lc_lang('AdminOnly',{'command':looney_admin_player},lc_user_lang))

def player_admin_talk():
    userid = es.getcmduserid()
    lc_user_lang = playerlib.getPlayer(userid).get('lang')
    words = es.getargc()
    if not is_Admin(userid):
        if words > 1:
            text = es.getargv(1)
            for word in range(2, words):
                next = es.getargv(word)
                text = '%s %s'%(text, next)
            for admins in playerlib.getPlayerList('#human'):
                admin = int(admins)
                if is_Admin(admin) and admin != userid:
                    es.tell(admin, '#multi', lc_lang('Player to Admins',{'sender':es.getplayername(userid),'text':text},playerlib.getPlayer(admin).get('lang')))
        else:
            es.tell(userid, '#multi', lc_lang('Syntax1',{'command':looney_player_admin},lc_user_lang))
    else:
        es.tell(userid, '#multi', lc_lang('PlayersOnly',{'command':looney_player_admin},lc_user_lang))

def es_player_chat(ev):
    if lc_alltext == 1:
        text = ev['text']
        userid = ev['userid']
        teamonly = ev['teamonly']
        team = int(ev['es_userteam'])
        dead = ev['es_userdead']
        name = ev['es_username']
        words = text.split()
        first = words[0]
        if not es.exists('saycommand', first):
            textstyle = 'DEAD' if dead == '1' else 'ALIVE'
            if teamonly == '1':
                for users in playerlib.getPlayerList('#human'):
                    user = int(users)
                    adminteam = es.getplayerteam(user)
                    if is_Admin(user) and team != adminteam:
                        es.tell(user, '#multi', lc_lang(textstyle,{'sender':name,'text':text},playerlib.getPlayer(user).get('lang')))
                if dead == '1':
                    for users in playerlib.getPlayerList('#human,#alive'):
                        adminteam = es.getplayerteam(users)
                        user = int(users)
                        if is_Admin(user) and adminteam == team and userid != user:
                            es.tell(user, '#multi', lc_lang(textstyle,{'sender':name,'text':text},playerlib.getPlayer(user).get('lang')))
            elif teamonly == '0' and dead == '1':
                for users in playerlib.getPlayerList('#human,#alive'):
                    user = int(users)
                    if is_Admin(user) and userid != user:
                        es.tell(user, '#multi', lc_lang(textstyle,{'sender':name,'text':text},playerlib.getPlayer(user).get('lang')))

def unload():
    if lc_admin_admin == 1:
        es.unregsaycmd(looney_admin_admin)
    if lc_admin_player == 1:
        es.unregsaycmd(looney_admin_player)
    if lc_player_admin == 1:
        es.unregsaycmd(looney_player_admin)